
// Objeto grid o matriz de pxeles

// Elementos y funciones que componen el objeto.

// Calculamos la matriz a partir del bitmap y el lado del cuadrado

// ********** CLASE GRID DE PXELES ******************************
class px_grid {

public:

	pixel** px_matriz;
	
	BITMAP* bmp;

	int lado;

	int color;
		
	int filas;

	int columnas;

public:

	// Un constructor por defecto. Sirve para declarar un grid 
	//px_grid( pixel** px_matriz=NULL , BITMAP* bmp=NULL, int lado=0 , int color=0, int filas=0 , int columnas=0 );

	px_grid( pixel** px_matriz=NULL , BITMAP* bmp=NULL , int lado=0 , int color=0 , int filas=0, int columnas=0 );

public:

	void set_dimensions(){
	
		this->filas = 1 +  (int) ( (bmp->h)/lado );

		this->columnas = 1 +  (int) ( (bmp->w)/lado );
			
	}


	void dogrid(){
	
		this->filas = 1 +  (int) ( (bmp->h)/lado );

		this->columnas = 1 +  (int) ( (bmp->w)/lado );

		pixel** matriz; int i=0; int j=0;

		// Reserva memoria
	
		matriz=(pixel**) malloc( filas*sizeof( pixel* ) );

		for( i=0 ; i<filas; i++){
	
			matriz[i]=(pixel*)malloc(columnas*sizeof(pixel));
	
		}
			i=0; j=0;

			// Rellena la matriz y situa sus puntos

			for(i=0; i<filas ; i++){
	
		for(j=0; j<columnas; j++){
		
			matriz[i][j].bmp=bmp;

			matriz[i][j].color=color;

			matriz[i][j].p.x=j*lado;

			matriz[i][j].p.y=i*lado;

			matriz[i][j].pon();
		
		
		}
	
	
	}

			this->px_matriz=matriz;
	
	
	}

	void liberamemoria(){
	
		for( int i=0; i < this->filas ; i++){
	
			free(  this->px_matriz[i] );
		
	}

		free( this->px_matriz );
		
		this->px_matriz=NULL;
	
	}
	
};

// El constructor de oficio: Las filas y columnas las calculamos en funcin del bitmap y del lado del cuadrado

// Necesitaremos una funcin para calcular las filas y las columnas 

px_grid :: px_grid( pixel** _px_matriz , BITMAP* _bmp , int _lado , int _color, int _filas , int _columnas ){

	px_matriz=_px_matriz;

	bmp=_bmp;

	lado=_lado;

	color=_color;

	filas=_filas;

	columnas=_columnas;
}

//************************************************************************

// ************* CLASE GRID DE CUADRADOS *************************


class q_grid {

public:

	quad** matriz; // La matriz de cuadrados
	
	BITMAP* bmp;

	int lado;
	
	int color;

	int filas;

	int columnas;


public:

	q_grid( quad** matriz=NULL, BITMAP* bmp=NULL, int lado=0, int color=C.WHITE, int filas=0, int columnas=0);
	
	// Constructor genrico

public:

	int optimizalado( int l_opt ) {
	
		int LM = mcd( this->bmp->w , this->bmp->h );
				
		while(  LM % l_opt !=0 ) {  l_opt = l_opt-1; } return l_opt;

	}
	
public:

	void setdimensions(){

		if( (this->lado) !=0 ) {

			if( this->filas==0 && this->columnas==0 ){ this->lado = this->optimizalado(this->lado); }
	
			this->filas = (int) (  (this->bmp->w) / (this->lado) ) ;
			this->columnas = (int)  ( (this->bmp->h) / (this->lado) ) ; 
		
		} else {
		
			if(  (this->filas) != 0 ){
			
				( this->lado ) =  ( int ) ( (this->bmp->h) / ( this->filas ) ); 

				this->columnas = (int)  ( (this->bmp->h) / (this->lado) ) ;

			
			}

			if(  (this->columnas) != 0 ){
			
				( this->lado ) =  ( int ) ( (this->bmp->w) / ( this->columnas ) ); 
			
				this->filas = (int) (  (this->bmp->w) / (this->lado) ) ;

			}
					
		}

	}


	void dogrid(){

		
		// Rellenamos la matriz y dibujamos los cuadrados 

		int i=0; 
		int j=0;

		for ( i=0 ; i<filas ; i++ ) {
		
			for( j=0; j<columnas; j++ ){
			
				this->matriz[ i ] [ j ].altura=this->lado;

				this->matriz[ i ] [ j ].anchura=this->lado;

				this->matriz [ i ] [ j ].bmp=this->bmp;

				// asignacin de colores, en funcin 
				// de las variables bool del cuadrado ij.
				 // if qij libre -> color_libre, etc.

				//if ( this->matriz[i][j].libre==true ) { this->matriz[i][j].color=color_libre; }
				//else { this->matriz [ i ] [ j ].color=C.AMARILLO_LIGHTYELLOW; }

				//----------------------------------
				
				this->matriz [ i ] [ j ].p1.x = j*( this->lado );

				this->matriz [ i ] [ j ].p1.y = i*( this->lado ) ;

				this->matriz [ i ] [ j ].p2.x = (j+1)*( this->lado );

				this->matriz [ i ] [ j ].p2.y = (i+1)*( this->lado ) ;

				//if (this->matriz[i][j].deplayer1==true) { this->matriz [ i ] [ j ].color=color_player1; }
				//if (this->matriz[i][j].deplayer2==true) { this->matriz [ i ] [ j ].color=color_player2;} 

				if(  this->matriz[i][j].libre==true ) { this->matriz [ i ] [ j ].color=color_libre; }
				//else{ this->matriz [ i ] [ j ].color=this->color; }

				if(  this->matriz[i][j].deplayer1==true ) { this->matriz [ i ] [ j ].color=color_player1; }
				//else{ this->matriz [ i ] [ j ].color=this->color; }
				if(  this->matriz[i][j].deplayer2==true ) { this->matriz [ i ] [ j ].color=color_player2; }

				// Si los cuadrados estn libres los pone al color de los libres, sino, los pone al color dado en
				// la definicin del grid.
				// Los cuadrados rellenos
				this->matriz[i][j].ponf( this->matriz[i][j].color  );
				// El permetro de los cuadrados
				this->matriz [ i ] [ j ].pon( color_grid );	 // pone el grid, pon() con color_grid
				
				// Si el cuadrado ha sido seleccionado por el player1, lo
				// pinta con el color del player1.
				//if ( this->matriz[i][j].deplayer1 ) this->matriz[i][j].ponf();
				 							
			} // bucle de columnas
						
		} // Bucle de filas

		//for(i=0;i<filas;i++){ for(j=0;j<columnas;j++){ this->matriz [ i ] [ j ].pon();  }  }
	}


	void reservamemoria(){

		this->setdimensions();
		
		int i=0; int j=0;

		// Reservamos memoria dinmica

		this->matriz = ( quad** ) malloc( (this->filas) * ( sizeof ( quad* ) ) ) ;

		for ( i=0 ; i<filas ; i++  ) {
		
			this->matriz[ i ] = ( quad* ) malloc (  ( this->columnas ) * sizeof( quad ) ) ;
		
		}

	}

	void limpiacuadros(){

		int i=0; int j=0;

		for ( i=0 ; i<filas ; i++ ) {
			for( j=0; j<columnas; j++ ){
			
				this->matriz[ i ] [ j ].libre=true;
				this->matriz[ i ] [ j ].deplayer1=false;
				this->matriz [ i ] [ j ].deplayer2=false;
				this->matriz[i][j].color=color_libre;
			}
    	}
		
	}

	// Liberamos la memoria

	void liberamemoria(){
	
		for( int i=0; i < this->filas ; i++){
	
			free(  this->matriz[i] );
		
	}

		free( this->matriz );
		
		this->matriz=NULL;
	}

	//

};


q_grid :: q_grid( quad** _matriz, BITMAP* _bmp, int _lado, int _color, int _filas, int _columnas ){

	matriz = _matriz;

	bmp = _bmp;

	lado = _lado;

	color = _color;

	filas=_filas;

	columnas=_columnas;
	
}







